////////////////////////////////////////////////////////////////////////////////
unit editos;
////////////////////////////////////////////////////////////////////////////////
interface
////////////////////////////////////////////////////////////////////////////////
uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
    Buttons, ExtCtrls, comctrls,dialogs;
////////////////////////////////////////////////////////////////////////////////

type
  TEditDlg = class(TForm)
    OKBtn: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Edit6: TEdit;
    procedure OKBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    osoba:TTreeNode;
    Matkaid:array of string;
    Otecid:array of string;
    procedure Zpracuj(s,v:String);
    procedure  Nuluj;
  end;

////////////////////////////////////////////////////////////////////////////////
var EditDlg: TEditDlg;
////////////////////////////////////////////////////////////////////////////////

implementation

uses mwin;
////////////////////////////////////////////////////////////////////////////////
// znuluje vsdechna data dialogu

procedure TEditDlg.Nuluj;
begin
  edit1.text:='';
  edit2.text:='';
  edit3.text:='';
  edit4.text:='';
  edit5.text:='';
  ComboBox2.ItemIndex:=-1;
  ComboBox2.ItemIndex:=-1;
end;

////////////////////////////////////////////////////////////////////////////////
// zpracovava nejakou polozku z osoby (nastavi edit nebo combo)

procedure TEditDlg.Zpracuj(s,v:String);
begin
  if s='jmeno' then edit1.text:=v;
  if s='id' then edit6.text:=v;
  if s='prijmeni' then edit2.text:=v;
  if s='pohlavi' then edit3.text:=v;
  if s='narozeni' then edit4.text:=v;
  if s='umrti' then edit5.text:=v;
  try
  if s='matka' then ComboBox1.ItemIndex:=strtoint(v);
  except
  ComboBox2.ItemIndex:=-1;
  end;
  try
  if s='otec' then ComboBox2.ItemIndex:=strtoint(v);
  except
  ComboBox2.ItemIndex:=-1;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
{$R *.DFM}
////////////////////////////////////////////////////////////////////////////////
// nastavi novou hodnotu polozky

procedure setitem(it:TTReeNode; s:string);
var Data:PChar;
begin
  FreeMem(it.Data);
  GetMem(Data,length(s)+1);
  s:=s+#0;
  strcopy(Data,@s[1]);
  it.Data:=Data;
end;

////////////////////////////////////////////////////////////////////////////////
// zapsat do stromove struktury nova data

procedure TEditDlg.OKBtnClick(Sender: TObject);
var it:TTReeNode;
    jm,pr,ph:string;
    i:integer;
begin
  it:=osoba;
  while (it<>nil) do begin// do stromove struktury
    if (it.Text='osoba') then break;
    if it.Text='jmeno' then begin setitem(it,Edit1.text); jm:=Edit1.text; end;
    if it.Text='prijmeni' then begin setitem(it,Edit2.text); pr:=Edit2.text; end;
    if it.Text='pohlavi' then begin setitem(it,Edit3.text); ph:=Edit3.text; end;
    if it.Text='narozeni' then  setitem(it,Edit4.text);
    if it.Text='umrti' then  setitem(it,Edit5.text);
    if it.Text='otec' then  setitem(it,otecid[combobox2.ItemIndex]);
    if it.Text='matka' then  setitem(it,otecid[combobox1.ItemIndex]);
    it:=it.GetNext;
  end;
  // do seznamu osob
  for i:=0 to Mainwin.Osoby.Count-1 do if TOsoba(Mainwin.Osoby.Items[i]).id=edit6.Text then begin
    TOsoba(Mainwin.Osoby.Items[i]).jm:=jm;
    TOsoba(Mainwin.Osoby.Items[i]).pr:=pr;
    TOsoba(Mainwin.Osoby.Items[i]).ph:=ph;
  end;
  // do poli matka a otec
  for i:=0 to Length(Matkaid)-1 do begin
    if Matkaid[i]=edit6.text then Combobox2.Items[i]:=jm+' '+pr;
  end;
  for i:=0 to Length(Otecid)-1 do begin
    if Otecid[i]=edit6.text then Combobox1.Items[i]:=jm+' '+pr;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
end.
